Index: trunk/images_nodist/presets/lottery.svg
===================================================================
--- trunk/images_nodist/presets/lottery.svg	(revision 11663)
+++ trunk/images_nodist/presets/lottery.svg	(revision 11663)
@@ -0,0 +1,347 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://inkscape.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="64"
+   height="64"
+   id="svg1307"
+   sodipodi:version="0.32"
+   inkscape:version="0.43"
+   version="1.0"
+   sodipodi:docbase="/tmp/wikinews"
+   sodipodi:docname="Lotto-v1.svg">
+  <defs
+     id="defs1309" />
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="4"
+     inkscape:cx="30.25"
+     inkscape:cy="23.910307"
+     inkscape:current-layer="layer1"
+     showgrid="true"
+     inkscape:document-units="px"
+     inkscape:grid-bbox="true"
+     inkscape:window-width="984"
+     inkscape:window-height="719"
+     inkscape:window-x="0"
+     inkscape:window-y="0" />
+  <metadata
+     id="metadata1312">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     id="layer1"
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer">
+    <g
+       id="g6865">
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="-1.3614551"
+         x="10.326274"
+         height="34"
+         width="50.067074"
+         id="rect2216"
+         style="fill:#d99f9f;fill-opacity:1;stroke:#000000;stroke-width:0.93292624;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="20.35981"
+         height="6"
+         width="6"
+         id="rect2224"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="28.35981"
+         height="6"
+         width="6"
+         id="rect2226"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="36.35981"
+         height="6"
+         width="6"
+         id="rect2228"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="44.35981"
+         height="6"
+         width="6"
+         id="rect2235"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="12.359811"
+         height="6"
+         width="6"
+         id="rect2286"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="0.60500801"
+         x="52.35981"
+         height="6"
+         width="6"
+         id="rect2288"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="20.35981"
+         height="6"
+         width="6"
+         id="rect2290"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="28.35981"
+         height="6"
+         width="6"
+         id="rect2292"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="36.359814"
+         height="6"
+         width="6"
+         id="rect2294"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="44.359814"
+         height="6"
+         width="6"
+         id="rect2296"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="12.359811"
+         height="6"
+         width="6"
+         id="rect2298"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="8.6050081"
+         x="52.359814"
+         height="6"
+         width="6"
+         id="rect2300"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="20.359804"
+         height="6"
+         width="6"
+         id="rect2302"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="28.359804"
+         height="6"
+         width="6"
+         id="rect2304"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="36.35981"
+         height="6"
+         width="6"
+         id="rect2306"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="44.35981"
+         height="6"
+         width="6"
+         id="rect2308"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="12.359806"
+         height="6"
+         width="6"
+         id="rect2310"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="16.605007"
+         x="52.35981"
+         height="6"
+         width="6"
+         id="rect2312"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="20.35981"
+         height="6"
+         width="6"
+         id="rect2314"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="28.35981"
+         height="6"
+         width="6"
+         id="rect2316"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="36.359818"
+         height="6"
+         width="6"
+         id="rect2318"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="44.359814"
+         height="6"
+         width="6"
+         id="rect2320"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="12.359812"
+         height="6"
+         width="6"
+         id="rect2322"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <rect
+         transform="matrix(0.963141,0.268997,-0.268997,0.963141,0,0)"
+         y="24.605007"
+         x="52.359814"
+         height="6"
+         width="6"
+         id="rect2324"
+         style="fill:none;fill-opacity:1;stroke:#b50023;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1" />
+      <path
+         id="path4082"
+         d="M 11.394423,3.291391 C 13.19723,7.6344064 14.111461,10.595961 15.865574,13.305076 C 16.073049,13.625509 16.407577,13.842783 16.678578,14.111636"
+         style="fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1" />
+      <path
+         id="path4084"
+         d="M 16.904272,5.868514 C 17.309376,6.4941709 15.445697,6.1804209 14.708993,6.293661 C 12.874321,6.5756717 11.899317,9.161173 10.609804,9.8182242"
+         style="fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1" />
+    </g>
+    <g
+       id="g6894"
+       transform="translate(-0.163838,-37.41383)">
+      <g
+         transform="matrix(1.310345,0,0,1.310345,-27.2672,12.59487)"
+         id="g4137">
+        <path
+           sodipodi:type="arc"
+           style="fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:0.76315778;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           id="path1315"
+           sodipodi:cx="19.710602"
+           sodipodi:cy="30.85437"
+           sodipodi:rx="6.805903"
+           sodipodi:ry="6.805903"
+           d="M 26.516505 30.85437 A 6.805903 6.805903 0 1 1  12.904699,30.85437 A 6.805903 6.805903 0 1 1  26.516505 30.85437 z"
+           transform="translate(33.5953,16.45153)" />
+        <text
+           xml:space="preserve"
+           style="font-size:6px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           x="49.560547"
+           y="49.453125"
+           id="text2212"
+           sodipodi:linespacing="125%"><tspan
+             sodipodi:role="line"
+             id="tspan2214"
+             x="49.560547"
+             y="49.453125">23</tspan></text>
+      </g>
+      <g
+         transform="matrix(1.310345,0,0,1.310345,-0.646509,6.456979)"
+         id="g4127">
+        <path
+           sodipodi:type="arc"
+           style="font-size:8px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;writing-mode:lr-tb;text-anchor:middle;fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:0.76315778;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           id="path2202"
+           sodipodi:cx="19.710602"
+           sodipodi:cy="30.85437"
+           sodipodi:rx="6.805903"
+           sodipodi:ry="6.805903"
+           d="M 26.516505 30.85437 A 6.805903 6.805903 0 1 1  12.904699,30.85437 A 6.805903 6.805903 0 1 1  26.516505 30.85437 z"
+           transform="translate(2.595301,21.45153)" />
+        <text
+           xml:space="preserve"
+           style="font-size:4.94748735px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:center;line-height:100%;writing-mode:lr-tb;text-anchor:middle;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           x="39.434193"
+           y="58.444778"
+           id="text2204"
+           sodipodi:linespacing="100%"
+           transform="matrix(1.143483,0.274659,-0.403949,0.777495,0,0)"><tspan
+             sodipodi:role="line"
+             id="tspan2206"
+             x="39.434193"
+             y="58.444778">12</tspan></text>
+      </g>
+      <g
+         transform="matrix(1.310345,0,0,1.310345,4.353479,2.465499)"
+         id="g4132">
+        <path
+           sodipodi:type="arc"
+           style="fill:#ffffff;fill-opacity:1;stroke:#000000;stroke-width:0.76315778;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           id="path2198"
+           sodipodi:cx="19.710602"
+           sodipodi:cy="30.85437"
+           sodipodi:rx="6.805903"
+           sodipodi:ry="6.805903"
+           d="M 26.516505 30.85437 A 6.805903 6.805903 0 1 1  12.904699,30.85437 A 6.805903 6.805903 0 1 1  26.516505 30.85437 z"
+           transform="translate(17.9835,18.83973)" />
+        <text
+           xml:space="preserve"
+           style="font-size:5.03230143px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           x="45.061573"
+           y="43.613289"
+           id="text2208"
+           sodipodi:linespacing="125%"
+           transform="scale(0.838717,1.192297)"><tspan
+             sodipodi:role="line"
+             id="tspan2210"
+             x="45.061573"
+             y="43.613289">42</tspan></text>
+      </g>
+    </g>
+  </g>
+</svg>