Index: trunk/src/org/openstreetmap/josm/data/coor/LatLon.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/coor/LatLon.java	(revision 12130)
+++ trunk/src/org/openstreetmap/josm/data/coor/LatLon.java	(revision 12131)
@@ -8,7 +8,7 @@
 import static java.lang.Math.sin;
 import static java.lang.Math.sqrt;
-import static java.lang.Math.toRadians;
 import static org.openstreetmap.josm.data.projection.Ellipsoid.WGS84;
 import static org.openstreetmap.josm.tools.I18n.trc;
+import static org.openstreetmap.josm.tools.Utils.toRadians;
 
 import java.awt.geom.Area;
Index: trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/StyledMapRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/StyledMapRenderer.java	(revision 12130)
+++ trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/StyledMapRenderer.java	(revision 12131)
@@ -286,5 +286,5 @@
     static final int FLAG_OUTERMEMBER_OF_SELECTED = 8;
 
-    private static final double PHI = Math.toRadians(20);
+    private static final double PHI = Utils.toRadians(20);
     private static final double cosPHI = Math.cos(PHI);
     private static final double sinPHI = Math.sin(PHI);
@@ -978,5 +978,5 @@
             fromAngle = Math.atan(dy / dx);
         }
-        double fromAngleDeg = Math.toDegrees(fromAngle);
+        double fromAngleDeg = Utils.toDegrees(fromAngle);
 
         double vx = distanceFromVia * Math.cos(fromAngle);
@@ -1001,9 +1001,9 @@
         if (pFrom.x >= pVia.x && pFrom.y >= pVia.y) {
             if (!leftHandTraffic) {
-                vx2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg - 90));
-                vy2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg - 90));
+                vx2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg - 90));
+                vy2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg - 90));
             } else {
-                vx2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg + 90));
-                vy2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg + 90));
+                vx2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg + 90));
+                vy2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg + 90));
             }
             iconAngle = 270+fromAngleDeg;
@@ -1011,9 +1011,9 @@
         if (pFrom.x < pVia.x && pFrom.y >= pVia.y) {
             if (!leftHandTraffic) {
-                vx2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg));
-                vy2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg));
+                vx2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg));
+                vy2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg));
             } else {
-                vx2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg + 180));
-                vy2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg + 180));
+                vx2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg + 180));
+                vy2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg + 180));
             }
             iconAngle = 90-fromAngleDeg;
@@ -1021,9 +1021,9 @@
         if (pFrom.x < pVia.x && pFrom.y < pVia.y) {
             if (!leftHandTraffic) {
-                vx2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg + 90));
-                vy2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg + 90));
+                vx2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg + 90));
+                vy2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg + 90));
             } else {
-                vx2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg - 90));
-                vy2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg - 90));
+                vx2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg - 90));
+                vy2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg - 90));
             }
             iconAngle = 90+fromAngleDeg;
@@ -1031,9 +1031,9 @@
         if (pFrom.x >= pVia.x && pFrom.y < pVia.y) {
             if (!leftHandTraffic) {
-                vx2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg + 180));
-                vy2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg + 180));
+                vx2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg + 180));
+                vy2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg + 180));
             } else {
-                vx2 = distanceFromWay * Math.sin(Math.toRadians(fromAngleDeg));
-                vy2 = distanceFromWay * Math.cos(Math.toRadians(fromAngleDeg));
+                vx2 = distanceFromWay * Math.sin(Utils.toRadians(fromAngleDeg));
+                vy2 = distanceFromWay * Math.cos(Utils.toRadians(fromAngleDeg));
             }
             iconAngle = 270-fromAngleDeg;
Index: trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/WireframeMapRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/WireframeMapRenderer.java	(revision 12130)
+++ trunk/src/org/openstreetmap/josm/data/osm/visitor/paint/WireframeMapRenderer.java	(revision 12131)
@@ -32,4 +32,5 @@
 import org.openstreetmap.josm.gui.NavigatableComponent;
 import org.openstreetmap.josm.gui.draw.MapPath2D;
+import org.openstreetmap.josm.tools.Utils;
 
 /**
@@ -90,5 +91,5 @@
 
     /** Helper variable for {@link #drawSegment} */
-    private static final ArrowPaintHelper ARROW_PAINT_HELPER = new ArrowPaintHelper(Math.toRadians(20), 10);
+    private static final ArrowPaintHelper ARROW_PAINT_HELPER = new ArrowPaintHelper(Utils.toRadians(20), 10);
 
     /** Helper variable for {@link #visit(Relation)} */
Index: trunk/src/org/openstreetmap/josm/data/validation/PaintVisitor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/validation/PaintVisitor.java	(revision 12130)
+++ trunk/src/org/openstreetmap/josm/data/validation/PaintVisitor.java	(revision 12131)
@@ -18,4 +18,5 @@
 import org.openstreetmap.josm.data.osm.visitor.AbstractVisitor;
 import org.openstreetmap.josm.gui.MapView;
+import org.openstreetmap.josm.tools.Utils;
 
 /**
@@ -144,5 +145,5 @@
         double cosT = 5 * Math.cos(t);
         double sinT = 5 * Math.sin(t);
-        int deg = (int) Math.toDegrees(t);
+        int deg = (int) Utils.toDegrees(t);
         if (selected) {
             g.setColor(getHighlightColor(color));