Index: trunk/src/org/openstreetmap/josm/gui/PleaseWaitDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/PleaseWaitDialog.java	(revision 12282)
+++ trunk/src/org/openstreetmap/josm/gui/PleaseWaitDialog.java	(revision 12285)
@@ -12,5 +12,4 @@
 
 import javax.swing.BorderFactory;
-import javax.swing.BoundedRangeModel;
 import javax.swing.JButton;
 import javax.swing.JDialog;
@@ -37,10 +36,5 @@
     private final JLabel currentAction = new JLabel("");
     private final JLabel customText = new JLabel("");
-    /**
-     * The direct progress access.
-     * @deprecated To be removed in mid-2017. Use {@link #updateProgress(int)}
-     */
-    @Deprecated
-    public final transient BoundedRangeModel progress = progressBar.getModel();
+
     private JButton btnCancel;
     private JButton btnInBackground;
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/LatLonDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/LatLonDialog.java	(revision 12282)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/LatLonDialog.java	(revision 12285)
@@ -320,15 +320,4 @@
     }
 
-    /**
-     * Parses the given string as lat/lon.
-     * @param coord String to parse
-     * @return parsed lat/lon
-     * @deprecated use {@link LatLon#parse(String)} instead
-     */
-    @Deprecated
-    public static LatLon parseLatLon(final String coord) {
-        return LatLon.parse(coord);
-    }
-
     public static EastNorth parseEastNorth(String s) {
         String[] en = s.split("[;, ]+");
Index: trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/AreaElement.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/AreaElement.java	(revision 12282)
+++ trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/AreaElement.java	(revision 12285)
@@ -40,11 +40,4 @@
      */
     public MapImage fillImage;
-
-    /**
-     * The text that should be written on this area.
-     * @deprecated Use {@link TextElement} instead.
-     */
-    @Deprecated
-    public TextLabel text;
 
     /**
@@ -127,10 +120,10 @@
                 }
             }
-            painter.drawArea((Way) osm, myColor, fillImage, extent, extentThreshold, painter.isInactiveMode() || osm.isDisabled(), text);
+            painter.drawArea((Way) osm, myColor, fillImage, extent, extentThreshold, painter.isInactiveMode() || osm.isDisabled());
         } else if (osm instanceof Relation) {
             if (color != null && (selected || outermember)) {
                 myColor = paintSettings.getRelationSelectedColor(color.getAlpha());
             }
-            painter.drawArea((Relation) osm, myColor, fillImage, extent, extentThreshold, painter.isInactiveMode() || osm.isDisabled(), text);
+            painter.drawArea((Relation) osm, myColor, fillImage, extent, extentThreshold, painter.isInactiveMode() || osm.isDisabled());
         }
     }
Index: trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/LineTextElement.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/LineTextElement.java	(revision 12282)
+++ 	(revision )
@@ -1,65 +1,0 @@
-// License: GPL. For details, see LICENSE file.
-package org.openstreetmap.josm.gui.mappaint.styleelement;
-
-import java.util.Objects;
-
-import org.openstreetmap.josm.data.osm.OsmPrimitive;
-import org.openstreetmap.josm.data.osm.visitor.paint.MapPaintSettings;
-import org.openstreetmap.josm.data.osm.visitor.paint.PaintColors;
-import org.openstreetmap.josm.data.osm.visitor.paint.StyledMapRenderer;
-import org.openstreetmap.josm.gui.mappaint.Cascade;
-import org.openstreetmap.josm.gui.mappaint.Environment;
-import org.openstreetmap.josm.gui.mappaint.Keyword;
-
-/**
- * A text that is only on the line
- * @deprecated since 11722. To be removed summer 2017
- */
-@Deprecated
-public class LineTextElement extends StyleElement {
-
-    private final TextLabel text;
-
-    protected LineTextElement(Cascade c, TextLabel text) {
-        super(c, 4.9f);
-        this.text = text;
-    }
-
-    public static LineTextElement create(final Environment env) {
-        final Cascade c = env.mc.getCascade(env.layer);
-
-        Keyword textPos = c.get(TEXT_POSITION, null, Keyword.class);
-        if (textPos != null && !"line".equals(textPos.val))
-            return null;
-
-        TextLabel text = TextLabel.create(env, PaintColors.TEXT.get(), false);
-        if (text == null)
-            return null;
-        return new LineTextElement(c, text);
-    }
-
-    @Override
-    public void paintPrimitive(OsmPrimitive primitive, MapPaintSettings paintSettings, StyledMapRenderer painter,
-            boolean selected, boolean outermember, boolean member) {
-        // nop
-    }
-
-    @Override
-    public boolean equals(Object obj) {
-        if (this == obj) return true;
-        if (obj == null || getClass() != obj.getClass()) return false;
-        if (!super.equals(obj)) return false;
-        LineTextElement that = (LineTextElement) obj;
-        return Objects.equals(text, that.text);
-    }
-
-    @Override
-    public int hashCode() {
-        return Objects.hash(super.hashCode(), text);
-    }
-
-    @Override
-    public String toString() {
-        return "LineTextElemStyle{" + super.toString() + "text=" + text + '}';
-    }
-}
Index: trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/TextLabel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/TextLabel.java	(revision 12282)
+++ trunk/src/org/openstreetmap/josm/gui/mappaint/styleelement/TextLabel.java	(revision 12285)
@@ -15,5 +15,4 @@
 import org.openstreetmap.josm.gui.mappaint.styleelement.LabelCompositionStrategy.StaticLabelCompositionStrategy;
 import org.openstreetmap.josm.gui.mappaint.styleelement.LabelCompositionStrategy.TagLookupCompositionStrategy;
-import org.openstreetmap.josm.gui.mappaint.styleelement.placement.CompletelyInsideAreaStrategy;
 import org.openstreetmap.josm.gui.mappaint.styleelement.placement.PositionForAreaStrategy;
 import org.openstreetmap.josm.tools.CheckParameterUtil;
@@ -61,22 +60,4 @@
      */
     private final PositionForAreaStrategy labelPositionStrategy;
-
-    /**
-     * Creates a new text element
-     *
-     * @param strategy the strategy indicating how the text is composed for a specific {@link OsmPrimitive} to be rendered.
-     * If null, no label is rendered.
-     * @param font the font to be used. Must not be null.
-     * @param xOffset x offset
-     * @param yOffset y offset
-     * @param color the color to be used. Must not be null
-     * @param haloRadius halo radius
-     * @param haloColor halo color
-     * @deprecated since 11722, To be removed in mid-2017
-     */
-    @Deprecated
-    public TextLabel(LabelCompositionStrategy strategy, Font font, int xOffset, int yOffset, Color color, Float haloRadius, Color haloColor) {
-        this(strategy, font, xOffset, yOffset, color, haloRadius, haloColor, CompletelyInsideAreaStrategy.INSTANCE);
-    }
 
     /**