Index: applications/editors/josm/i18n/po/fr.po
===================================================================
--- applications/editors/josm/i18n/po/fr.po	(revision 12484)
+++ applications/editors/josm/i18n/po/fr.po	(revision 12493)
@@ -6,5 +6,5 @@
 "Project-Id-Version: fr\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2008-12-22 18:35+0100\n"
+"POT-Creation-Date: 2008-12-22 23:24+0100\n"
 "PO-Revision-Date: 2008-11-19 22:37+0100\n"
 "Last-Translator: Frederic Bonifas <fredericbonifas@gmail.com>\n"
@@ -59,10 +59,4 @@
 msgid "Information"
 msgstr "Information"
-
-#: ../core/src/org/openstreetmap/josm/tools/XmlObjectParser.java:32
-#: ../core/src/org/openstreetmap/josm/gui/GettingStarted.java:98
-#: ../core/src/org/openstreetmap/josm/actions/HelpAction.java:48
-msgid "En:"
-msgstr "En :"
 
 #: ../core/src/org/openstreetmap/josm/tools/BugReportExceptionHandler.java:64
@@ -336,5 +330,5 @@
 msgstr "Échec..."
 
-#: ../core/src/org/openstreetmap/josm/Main.java:207
+#: ../core/src/org/openstreetmap/josm/Main.java:208
 #: ../core/src/org/openstreetmap/josm/gui/MainMenu.java:138
 #: ../core/src/org/openstreetmap/josm/gui/MainMenu.java:262
@@ -343,5 +337,5 @@
 msgstr "Aide"
 
-#: ../core/src/org/openstreetmap/josm/Main.java:238
+#: ../core/src/org/openstreetmap/josm/Main.java:239
 #, java-format
 msgid ""
@@ -352,20 +346,20 @@
 "nécessaire."
 
-#: ../core/src/org/openstreetmap/josm/Main.java:259
+#: ../core/src/org/openstreetmap/josm/Main.java:260
 #, java-format
 msgid "Plugin requires JOSM update: {0}."
 msgstr ""
 
-#: ../core/src/org/openstreetmap/josm/Main.java:270
+#: ../core/src/org/openstreetmap/josm/Main.java:271
 #, java-format
 msgid "Plugin not found: {0}."
 msgstr "Greffon non trouvé : {0}"
 
-#: ../core/src/org/openstreetmap/josm/Main.java:284
+#: ../core/src/org/openstreetmap/josm/Main.java:285
 #, java-format
 msgid "Last plugin update more than {0} days ago."
 msgstr ""
 
-#: ../core/src/org/openstreetmap/josm/Main.java:286
+#: ../core/src/org/openstreetmap/josm/Main.java:287
 msgid ""
 "(You can change the number of days after which this warning appears<br>by "
@@ -373,10 +367,10 @@
 msgstr ""
 
-#: ../core/src/org/openstreetmap/josm/Main.java:317
+#: ../core/src/org/openstreetmap/josm/Main.java:318
 #, fuzzy, java-format
 msgid "Could not load plugin {0}. Delete from preferences?"
 msgstr "Impossible de charger le greffon {0}. Supprimer des préférences ?"
 
-#: ../core/src/org/openstreetmap/josm/Main.java:388
+#: ../core/src/org/openstreetmap/josm/Main.java:389
 msgid "The projection could not be read from preferences. Using EPSG:4263."
 msgstr ""
@@ -384,5 +378,5 @@
 "utilisé."
 
-#: ../core/src/org/openstreetmap/josm/Main.java:460
+#: ../core/src/org/openstreetmap/josm/Main.java:461
 msgid "Hint: Some changes came from uploading new data to the server."
 msgstr ""
@@ -390,20 +384,20 @@
 "sur le serveur."
 
-#: ../core/src/org/openstreetmap/josm/Main.java:462
+#: ../core/src/org/openstreetmap/josm/Main.java:463
 #, fuzzy
 msgid "There are unsaved changes. Discard the changes and continue?"
 msgstr "Certains changements ne sont pas sauvegardés. Quitter quand même ?"
 
-#: ../core/src/org/openstreetmap/josm/Main.java:463
+#: ../core/src/org/openstreetmap/josm/Main.java:464
 #: ../core/src/org/openstreetmap/josm/gui/dialogs/LayerListDialog.java:80
 msgid "Unsaved Changes"
 msgstr "Changements non sauvegardés"
 
-#: ../core/src/org/openstreetmap/josm/Main.java:475
+#: ../core/src/org/openstreetmap/josm/Main.java:476
 #, java-format
 msgid "Ignoring malformed url: \"{0}\""
 msgstr "Ignore l'URL malformé : \"{0}\""
 
-#: ../core/src/org/openstreetmap/josm/Main.java:488
+#: ../core/src/org/openstreetmap/josm/Main.java:489
 #, java-format
 msgid "Ignoring malformed file url: \"{0}\""
@@ -620,5 +614,5 @@
 
 #: ../core/src/org/openstreetmap/josm/gui/GettingStarted.java:53
-#: ../core/src/org/openstreetmap/josm/gui/GettingStarted.java:125
+#: ../core/src/org/openstreetmap/josm/gui/GettingStarted.java:123
 #, fuzzy
 msgid "JOSM, the Java OpenStreetMap editor"
@@ -3317,5 +3311,5 @@
 msgstr[1] "{0} noeuds"
 
-#: ../core/src/org/openstreetmap/josm/data/osm/Relation.java:89
+#: ../core/src/org/openstreetmap/josm/data/osm/Relation.java:90
 #, fuzzy, java-format
 msgid "{0} member"
@@ -11253,2 +11247,5 @@
 msgid "could not get audio input stream from input URL"
 msgstr "impossible d'obtenir un flux audio depuis l'URL"
+
+#~ msgid "En:"
+#~ msgstr "En :"